// under linux: gcc -Wall -lsocket -lnsl -o sdkbot sdkbot.cpp
// under win32 include wsock32.lib

//#include "bot.h"

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#ifdef WIN32
	#include <winsock.h>
	#include <conio.h>
#else
	#include <unistd.h>
	#include <sys/socket.h>
	#include <netinet/in.h>
	#include <sys/types.h>
	#include <netdb.h>
	#include <errno.h>
	#include <termios.h>
	#include <fcntl.h>
#endif

//namespace sockclient
//{

void run(void);

#ifndef WIN32
int kbhit(void) {
        struct termios term, oterm;
        int fd = 0;
        int c = 0;
        tcgetattr(fd, &oterm);
        memcpy(&term, &oterm, sizeof(term));
        term.c_lflag = term.c_lflag & (!ICANON);
        term.c_cc[VMIN] = 0;
        term.c_cc[VTIME] = 1;
        tcsetattr(fd, TCSANOW, &term);
        c = getchar();
        tcsetattr(fd, TCSANOW, &oterm);
        if (c != -1)
        ungetc(c, stdin);
        return ((c != -1) ? 1 : 0);
}
#endif

int sck;
char buf[1024];

int main(int args, char **argv)
{
	if(args!=3)
	{
		printf("Usage: sockclient www.google.com 80\ntype QUIT to exit\n");
	}
#ifndef WIN32
    struct termios term, oterm;
#endif
#ifdef WIN32
	WORD version = MAKEWORD(1,1);
	WSADATA wsaData;
	WSAStartup(version, &wsaData);
#endif
#ifdef WIN32
	sck = socket(AF_INET, SOCK_STREAM, 0);
#else
	sck = socket(AF_INET, SOCK_STREAM, getprotobyname("tcp")->p_proto);
#endif
	if(sck<=0)
		printf("error %d (socket)", sck);
	struct sockaddr_in adr;
	struct hostent *he;
	memset((char *)&adr,0,sizeof(adr)); 
	adr.sin_family = AF_INET;
	adr.sin_port = htons(atoi(argv[2]));
	if ((he=gethostbyname(argv[1])) == NULL)
		printf("error %d (gethostbyname)", 0);
	adr.sin_addr = *((struct in_addr *)he->h_addr);
	memset(&(adr.sin_zero), 0, 8);
	if(connect(sck, (struct sockaddr *)&adr, sizeof(struct sockaddr))!=0) printf("error (connect)");
	//char buf[1024];
#ifdef WIN32
	int to = 100;
	setsockopt(sck, SOL_SOCKET, SO_RCVTIMEO, (char *)&to, sizeof(to));

#else
	int flags = fcntl( sck, F_GETFL, 0);
	flags = flags | O_NONBLOCK;
	fcntl( sck, F_SETFL, flags );

#endif
/*	strcpy(buf, "JOIN ");
	strcat(buf, chn);
	strcat(buf, "\n");
	if(send(sck, buf, strlen(buf), 0) < 0) printf("error (send)");*/
/*	if(recv(sck, buf, 1024, 0) < 0) printf("error (recv)");;
	printf("%s\n", buf);*/

#ifndef WIN32
    int fd = 0;
    tcgetattr(fd, &oterm);
    memcpy(&term, &oterm, sizeof(term));
    term.c_lflag = term.c_lflag & (!ICANON);
    term.c_cc[VMIN] = 0;
    term.c_cc[VTIME] = 1;
    tcsetattr(fd, TCSANOW, &term);
#endif

	run();
#ifdef WIN32
	shutdown(sck, 2);
	WSACleanup();
#else
    fd = 0;
    tcsetattr(fd, TCSANOW, &oterm);
	shutdown(sck, SHUT_RDWR);
#endif
	return 0;
}




void Send(char *msg)
{
	if(msg[0] == '/')
		msg++;
	printf("Send: %s", msg);
	if(send(sck, msg, strlen(msg), 0) < 0) printf("error (send)");
}

void Recv(char *msg)
{
	printf("Recv: %s", msg);
	/*if(strstr(msg, "PING") == msg || strstr(msg, "\nPING"))
	{
		char pong[80];
		strcpy(pong, "PONG ");
		strcat(pong, strstr(msg, "PING")+6);
		//strcat(pong, "\n");
		printf("PING? PONG!\n");
		Send(pong);
	}*/
	if(strstr(msg, "ERROR") == msg && strstr(msg, "\nClosing Link"))
	{
		//ircconnect();
	}
}

int off;
bool quit = false;

void step(void)
{
#ifdef WIN32
	if(kbhit())
#else
	if((buf[off] = getchar())!=-1)
#endif
	{
#ifdef WIN32
		buf[off] = getch();
#endif
		printf("%c", buf[off]);
		if(buf[off] == '\n' || buf[off] == '\r')
		{
#ifdef WIN32
			if(buf[off]=='\r') buf[off] = '\n';
			printf("\n");
#endif
			buf[off+1] = 0;
			Send(buf);
			off = 0;
			if(!strcmp(buf, "QUIT\n") || !strcmp(buf, "QUIT\r\n"))
			{
				quit = true;
			}
			memset(buf, 0, 1024);
		}
		else
		{
			off++;
		}
	}
	else
	{
		char bufr[1024] = "";
		memset(bufr, 0, 1024);
		recv(sck, bufr, 1024, 0);
		if(bufr[0]!=0)
		{
			char *str = bufr;
			char *str2 = bufr;
			while(strstr(str2, "\n") && (int)(strstr(str2, "\n") - str2) < (int)strlen(str2)-2)
			{
				str = strstr(str2, "\n");
				*str = 0;
				str++;
				Recv(str2);
				str2 = str;
			}
			Recv(str2);
		}
	}
}

void run(void)
{
	off = 0;
	strcpy(buf, "");
	while(!quit)
	{
		step();
	}
}

//csdkbot sdkbot;

//}

/*int main(void)
{
	sdkbot::sdkbot.run();
	return 0;
}*/
